Attribute VB_Name = "vdplib"
'Excel interface to pressure drop library dplib through the routines in vdplib.c
'Rnr - Refrigerant no
'M   - is massflow in kg/m2s
't   - temperature Celsius
'p   - pressure i Pa
'x   - vapour quality (0 or 1 in Single phase)
'd   - hydraulic diameter in meter
'qfl - heat flux in W/m2

Private Declare Function _
vXiTstk Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, a1 As Double, a2 As Double, qa1 As Double, qa2 As Double, k As Integer, xi As Double) As Integer

Private Declare Function _
vXiValve Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, yd As Double, xi As Double) As Integer

Private Declare Function _
vdpdlBlasius Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlBlasiusWebb Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlSwamee Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlSelander Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlSelander2 Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlHaaland Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlChurchill Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlPethukov Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlGronnerud Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, qfl As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlFriedel Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, angle As Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlFriedel2 Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, angle As Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlChisholmMod Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlFuchs2 Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlFuchsNeraas Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, dCorr As Integer, dpdl As Double) As Integer

Private Declare Function _
vdpdlNeraas Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, dCorr As Integer, dpdl As Double) As Integer

Private Declare Function _
vdpdlCESNEF2 Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, angle as Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlCESNEF1 Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, angle as Double, k As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlTranWambsganns99 Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, angle as Double, k As Double, dpdl As Double) As Integer


Private Declare Function _
vdpGravity Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, h As Double, vcorr As Integer, dp As Double) As Integer


Private Declare Function _
vdpdlGravity Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, angle As Integer, vcorr As Integer, dpdl As Double) As Integer

Private Declare Function _
vdpBendUpward Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, rad As Double, deg As Double, dp As Double) As Integer

Private Declare Function _
vdpBendChisholm Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, rad As Double, deg As Double, incl As Double, dp As Double) As Integer

Private Declare Function _
vdpBendChisholm67 Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, rad As Double, deg As Double, incl As Double, dp As Double) As Integer

Private Declare Function _
vdpBendEquivLength Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, rad As Double, deg As Double, incl As Double, dpcorr As Integer, dCorrNeraas As Integer, dp As Double) As Integer

Private Declare Function _
vdpInletManifold Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, m As Double, x As Double, t As Double, p As Double, _
d As Double, d1 As Double, d2 As Double, tp As Double, N1 As Integer, N2 As Integer, dp As Double) As Integer

Private Declare Function _
vdpOutletManifold Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, _
d As Double, d1 As Double, d2 As Double, tp As Double, n1 As Integer, n2 As Integer, dp As Double) As Integer

Private Declare Function _
vdpdlAcceleration Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, qfl As Double, t As Double, p As Double, d As Double, angle As Double, vcorr As Integer, dpdl As Double) As Integer

Private Declare Function _
vdpdlAccGronnerud Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, qfl As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpdlAccFuchs Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, qfl As Double, t As Double, p As Double, d As Double, dpdl As Double) As Integer

Private Declare Function _
vdpAcceleration Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, qfl As Double, t As Double, p As Double, d As Double, angle As Double, vcorr As Integer, dp As Double) As Integer

Private Declare Function _
vgetDensity Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, angle As Double, vcorr As Integer, rho As Double) As Integer


Private Declare Function _
vdpEquivLength Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, xi As Double, dp As Double) As Integer

Private Declare Function _
vEquivLength Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, x As Double, t As Double, p As Double, d As Double, xi As Double, length As Double) As Integer


Private Declare Function _
vdpDistrTube Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, Gs As Double, d As Double, l As Double, ent As Double, p As Double, k As Double, dpCorr As Integer, dp As Double) As Integer

Private Declare Function _
vuzDistrTube Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, Gs As Double, d As Double, z As Double, ent As Double, p As Double, k As Double, dpCorr As Integer, vCorr As Integer, u As Double) As Integer


Private Declare Function _
vVoidHomogeneous Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, t As Double, p As Double, x As Double, alfa As Double) As Integer

Private Declare Function _
vVoidZivi Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, t As Double, p As Double, x As Double, alfa As Double) As Integer

Private Declare Function _
vVoidKowalczewski Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, K As Double, alfa As Double) As Integer

Private Declare Function _
vVoidRouhani Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, alfa As Double) As Integer

Private Declare Function _
vVoidCise Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, alfa As Double) As Integer

Private Declare Function _
vVoidACRC Lib "c:\kktdlls\vdplib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, alfa As Double) As Integer

Private Function checkError(ierr, answ)
     If (ierr = 1) Then
       fret = answ
     ElseIf (ierr = 0) Then
       fret = "Error selecting refrigerant"
     ElseIf (ierr = -1) Then
       fret = "Error: Massflow must be > 0!"
     ElseIf (ierr = -2) Then
       fret = "Error: Hydraulic diameter must be > 0"
     ElseIf (ierr = -3) Then
       fret = "Error: Single phase correlation for two-phase flow"
     End If
     checkError = fret
End Function


Public Function dpdlBlasius(R, M, x, t, p, d)
Attribute dpdlBlasius.VB_Description = "Single phase pressure drop gradient using the Blasius equation.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlBlasius(R, M, x, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlBlasius = fret
End Function

Public Function dpdlBlasiusWebb(R, M, x, t, p, d)
Attribute dpdlBlasiusWebb.VB_Description = "Single phase pressure drop gradient using the Blasius-Webb equation. Suitable for small diameter tubes.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlBlasiusWebb(R, M, x, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlBlasiusWebb = fret
End Function

Public Function dpdlSwamee(R, M, x, t, p, d, k)
Attribute dpdlSwamee.VB_Description = "Single phase pressure drop gradient using the Swamee (explicit Colbrooke-White) equation for the friction coefficient.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlSwamee(R, M, x, t, p, d, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlSwamee = fret
End Function

Public Function dpdlSelander(R, M, x, t, p, d, k)
Attribute dpdlSelander.VB_Description = "Single phase pressure drop gradient using the Selander (explicit Colbrooke-White) equation for the friction coefficient.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlSelander(R, M, x, t, p, d, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlSelander = fret
End Function

Public Function dpdlSelander2(R, M, x, t, p, d, k)
Attribute dpdlSelander2.VB_Description = "Single phase pressure drop gradient using the Selander (explicit Colbrooke-White) equation for the friction coefficient.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlSelander2(R, M, x, t, p, d, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlSelander2 = fret
End Function

Public Function dpdlHaaland(R, M, x, t, p, d, k)
Attribute dpdlHaaland.VB_Description = "Single phase pressure drop gradient using the Haaland (explicit Colbrooke-White) equation for the friction coefficient.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlHaaland(R, M, x, t, p, d, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlHaaland = fret
End Function

Public Function dpdlChurchill(R, M, x, t, p, d, k)
Attribute dpdlChurchill.VB_Description = "Single phase pressure drop gradient using the Churchill (explicit Colbrooke-White) equation for the friction coefficient.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlChurchill(R, M, x, t, p, d, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlChurchill = fret
End Function

Public Function dpdlPethukov(R, M, x, t, p, d)
Attribute dpdlPethukov.VB_Description = "Single phase pressure drop gradient using the Pethukov equation.\\r\\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlPethukov(R, M, x, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlPethukov = fret
End Function

Public Function dpdlGronnerud(R, M, x, qfl, t, p, d)
Attribute dpdlGronnerud.VB_Description = "Two phase pressure drop gradient using a modified Grnnerud equation.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), heat flux , qfl (W/m), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlGronnerud(R, M, x, qfl, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlGronnerud = fret
End Function

Public Function dpdlFriedel(R, M, x, t, p, d, angle, k)
     ret = vdpdlFriedel(R, M, x, t, p, d, angle, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlFriedel = fret
End Function

Public Function dpdlFriedel2(R, M, x, t, p, d, angle, k)
     ret = vdpdlFriedel2(R, M, x, t, p, d, angle, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlFriedel2 = fret
End Function

Public Function dpdlChisholmMod(R, M, x, t, p, d)
Attribute dpdlChisholmMod.VB_Description = "Two-phase pressure drop gradient using a modified Chisholm equation for small diamter tubes.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlChisholmMod(R, M, x, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlChisholmMod = fret
End Function

Public Function dpdlFuchs2 (R, M, x, t, p, d)
Attribute dpdlFuchs2.VB_Description = "Two-phase pressure drop gradient using the Fuchs correlation with Fr=1.0.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlFuchs2(R, M, x, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlFuchs2 = fret
End Function

Public Function dpdlFuchsNeraas(R, M, x, t, p, d, dCorr)
Attribute dpdlFuchsNeraas.VB_Description = "Two-phase pressure drop gradient using the Fuchs/Neraas correlation.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa), hydraulic diameter, d (m) and density correction flag"
     ret = vdpdlFuchsNeraas(R, M, x, t, p, d, dCorr, dpdl)
     fret = checkError(ret, dpdl)
     dpdlFuchsNeraas = fret
End Function


Public Function dpdlNeraas(R, M, x, t, p, d, dCorr)
Attribute dpdlNeraas.VB_Description = "Two-phase pressure drop gradient using the Neraas(95) correlation.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa), hydraulic diameter, d (m) and density-correction flag (0/1)"
     ret = vdpdlNeraas(R, M, x, t, p, d, dCorr, dpdl)
     fret = checkError(ret, dpdl)
     dpdlNeraas = fret
End Function

Public Function dpdlCESNEF2(R, M, x, t, p, d, angle, k)
Attribute dpdlCESNEF2.VB_Description = "Two-phase pressure drop gradient using the CESNEF2 correlation.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlCESNEF2(R, M, x, t, p, d, angle, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlCESNEF2 = fret
End Function

Public Function dpdlCESNEF1(R, M, x, t, p, d, angle, k)
Attribute dpdlCESNEF1.VB_Description = "Two-phase pressure drop gradient using the CESNEF1 correlation.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlCESNEF1(R, M, x, t, p, d, angle, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlCESNEF1 = fret
End Function

Public Function dpdlTranWambsganns99(R, M, x, t, p, d, angle, k)
Attribute dpdlTranWambsganns99.VB_Description = "Two-phase pressure drop gradient using the TranWambsganns(99) correlation.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa) and hydraulic diameter, d (m)"
     ret = vdpdlTranWambsganns99(R, M, x, t, p, d, angle, k, dpdl)
     fret = checkError(ret, dpdl)
     dpdlTranWambsganns99 = fret
End Function


Public Function dpGravity(R, M, x, t, p, d, h, vcorr)
Attribute dpGravity.VB_Description = "Gravity pressure drop/increase using Kowalscewski's void correlation for the two-phase density."
     ret = vdpGravity(R, M, x, t, p, d, h, vcorr, dp)
     fret = checkError(ret, dp)
     dpGravity = fret
End Function


Public Function dpdlGravity(R, M, x, t, p, d, angle, vcorr)
Attribute dpdlGravity.VB_Description = "Gravity pressure gradient using Kowalscewski's void correlation for the two-phase density."
     ret = vdpdlGravity(R, M, x, t, p, d, angle, vcorr, dpdl)
     fret = checkError(ret, dpdl)
     dpdlGravity = fret
End Function

Public Function dpBendUpward(R, M, x, t, p, d, rad, deg)
Attribute dpBendUpward.VB_Description = "Two-phase pressure drop in upward bends 90 or 180 degrees using the Grnnerud correlation."
     ret = vdpBendUpward(R, M, x, t, p, d, rad, deg, dp)
     fret = checkError(ret, dp)
     dpBendUpward = fret
End Function

Public Function dpBendChisholm(R, M, x, t, p, d, rad, deg, incl)
Attribute dpBendChisholm.VB_Description = "Two-phase pressure drop in bends 90 or 180 degrees with inclination, incl using Chisholms method."
     ret = vdpBendChisholm(R, M, x, t, p, d, rad, deg, incl, dp)
     fret = checkError(ret, dp)
     dpBendChisholm = fret
End Function


Public Function dpBendChisholm67(R, M, x, t, p, d, rad, deg, incl)
Attribute dpBendChisholm67.VB_Description = "Two-phase pressure drop in bends 90 or 180 degrees with inclination, incl using Chisholms (1967) method."
     ret = vdpBendChisholm67(R, M, x, t, p, d, rad, deg, incl, dp)
     fret = checkError(ret, dp)
     dpBendChisholm67 = fret
End Function

Public Function dpBendEquivLength(R, M, x, t, p, d, rad, deg, incl, dpcorr, dCorrNeraas)
Attribute dpBendEquivLength.VB_Description = "Two-phase pressure drop in bends 90 or 180 degrees with inclination, incl using Equivalent Length method."
     ret = vdpBendEquivLength(R, M, x, t, p, d, rad, deg, incl, dpcorr, dCorrNeraas, dp)
     fret = checkError(ret, dp)
     dpBendEquivLength = fret
End Function

Public Function dpInletManifold(R, M, x, t, p, d, d1, d2, tp, n1, n2)
Attribute dpInletManifold.VB_Description = "Pressure drop in inlet manifold.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa), diameters, d, d1, d2, tube pitch tp, and number of liquid tubes (n1) and distributor tubes (n2)"
     ret = vdpInletManifold(R, M, x, t, p, d, d1, d2, tp, n1, n2, dp)
     fret = checkError(ret, dpdl)
     dpInletManifold = fret
End Function


Public Function dpOutletManifold(R, M, x, t, p, d, d1, d2, tp, n1, n2)
Attribute dpOutletManifold.VB_Description = "Pressure drop in outlet manifold.\r\nInput: Massflow, M (kg/ms), vapour fraction, x (-), temperature, t (C), pressure, p (Pa), diameters, d, d1, d2, tube pitch tp, and number of inlet (n1) and outlet tubes (n2)"
     ret = vdpOutletManifold(R, M, x, t, p, d, d1, d2, tp, n1, n2, dp)
     fret = checkError(ret, dp)
     dpOutletManifold = fret
End Function

Public Function dpAcceleration(R, M, x, qfl, t, p, d, angle, vcorr)
     ret = vdpAcceleration(R, M, x, qfl, t, p, d, angle, vcorr, dpdl)
     fret = checkError(ret, dpdl)
     dpAcceleration = fret
End Function

Public Function dpdlAcceleration(R, M, x, qfl, t, p, d, angle, vcorr)
     ret = vdpdlAcceleration(R, M, x, qfl, t, p, d, angle, vcorr, dpdl)
     fret = checkError(ret, dpdl)
     dpdlAcceleration = fret
End Function

Public Function dpdlAccGronnerud(R, M, x, qfl, t, p, d)
     ret = vdpdlAccGronnerud(R, M, x, qfl, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlAccGronnerud = fret
End Function

Public Function dpdlAccFuchs(R, M, x, qfl, t, p, d)
     ret = vdpdlAccFuchs(R, M, x, qfl, t, p, d, dpdl)
     fret = checkError(ret, dpdl)
     dpdlAccFuchs = fret
End Function


Public Function getDensity(R, M, x, t, p, d, angle, vcorr)
Attribute getDensity.VB_Description = "Calculate the local density of the flow, using the local void fraction in the two-phase region"
     ret = vgetDensity(R, M, x, t, p, d, angle, vcorr, rho)
     fret = checkError(ret, rho)
     getDensity = fret
End Function

Public Function dpEquivLength(R, M, x, t, p, d, xi)
Attribute dpEquivLength.VB_Description = "Calculate two-phase pressure drop using equivalent length method"
     ret = vdpEquivLength(R, M, x, t, p, d, xi, dp)
     fret = checkError(ret, dp)
     dpEquivLength = fret
End Function


Public Function EquivLength(R, M, x, t, p, d, xi)
Attribute EquivLength.VB_Description = "Calculate equivalent length for two-phase pressure drop"
     ret = vEquivLength(R, M, x, t, p, d, xi, length)
     fret = checkError(ret, length)
     EquivLength = fret
End Function


Public Function dpDistrTube(R, Gs, d, l, ent, p, k, dpCorr)
Attribute dpDistrTube.VB_Description = "Pressure drop in capillary tube\r\nInput: Refrigerant, Gsirk (kg/s), diameter (m), length (m), enthalpy (J/kg K), pressure (Pa), Surface roughness (m), Correlation (0=Friedel, 1=Grnnerud)"
    ret = vdpDistrTube(R, Gs, d, l, ent, p, k, dpCorr, dp)
    fret = checkError(ret, dp)
    dpDistrTube = fret
End Function

Public Function uzDistrTube(R, Gs, d, z, ent, p, k, dpCorr, vCorr)
Attribute uzDistrTube.VB_Description = "Two-phase velocity in capillary tube\ronInput: Refrigerant, Gsirk (kg/s), diameter (m), Distance from oulet (m), enthalpy (J/kg K), pressure (Pa), Surface roughness (m), dpCorrelation (0=Friedel, 1=Grnnerud, voidCorrelation (0:Homogenous,1:Kowalscweski,2:Rouhani,3:ACRC)"
    ret = vuzDistrTube(R, Gs, d, l, ent, p, k, dpCorr, vCorr, u)
    fret = checkError(ret, u)
    uzDistrTube = fret
End Function


Public Function XiTstk(R, a1, a2, qa1, qa2, k)
        ret = vXiTstk(R, a1, a2, qa1, qa2, k, xi)
        fret = checkError(ret, xi)
        XiTstk = fret
End Function

Public Function XiValve(R, yd)
        ret = vXiValve(R, yd, xi)
        fret = checkError(ret, xi)
        XiValve = fret
End Function

Public Function voidKowalczewski (R, M, t, p, x, d, K)
	ret = vVoidKowalczewski (R, M, t, p, x, d, K, alfa)
	voidKowalczewski = fret
End Function

Public Function voidHomogeneous (R, t, p, x)
	ret = vVoidHomogeneous (R, t, p, x, alfa)
	voidHomogeneous = fret
End Function

Public Function voidZivi (R, t, p, x)
	ret = vVoidZivi (R, t, p, x, alfa)
	voidZivi = fret
End Function

Public Function voidRouhani (R, M, t, p, x )
	ret = vVoidRouhani (R, M, t, p, x, alfa)
	voidRouhani = fret
End Function

Public Function voidCISE (R, M, t, p, x, d)
	ret = vVoidCise (R, M, t, p, x, d, alfa)
	voidCISE = fret 
End Function


Public Function voidACRC (R, M, t, p, x, d)
	ret = vVoidACRC (R, M, t, p, x, d, alfa)
	voidACRC = fret
End Function




