Attribute VB_Name = "htclib"
'Excel interface to heat transfer coefficient library htclib calling routines in vhtclib.c
'Rnr - Refrigerant no
'M   - is massflow in kg/m2s
't   - temperature Celsius
'p   - pressure i Pa
'x   - vapour quality (0 or 1 in Single phase)
'd   - hydraulic diameter in meter
'qfl - heat flux in W/m2 (where necessary)
'tw  - wall temperature (where necessary)
'dz  - length of control-volume (where asked for)


Private Declare Function _
vhtcGascooler Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, htc As Double) As Integer


' Single phase low pressure

Private Declare Function _
vhtcSingleDittusBoelter Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, htc As Double) As Integer

Private Declare Function _
vhtcSingleGnielinski Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, z As Double, k As Double, htc As Double) As Integer

' Single phase high pressure

Private Declare Function _
vhtcSuperKakac Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, htc As Double) As Integer

Private Declare Function _
vhtcSuperJacksonFewster Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, qw As Double, t As Double, p As Double, x As Double, d As Double, htc As Double) As Integer


Private Declare Function _
vhtcSuperPetukhov Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, htc As Double) As Integer

' Single phase supercritical pressure
   
Private Declare Function _
vhtcSuperGhajarAsadi Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, qw As Double, t As Double, p As Double, d As Double, htc As Double) As Integer


Private Declare Function _
vhtcSuperPolyakov Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, qw As Double, t As Double, p As Double, d As Double, htc As Double) As Integer

' Two phase flow evaporator

'
'   Automatic switch to GungoeWinterton87 for CO2 */
'   Automatic switch to Hauks for NH3
'


Private Declare Function _
vhtcEvapKKT Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, q As Double, d As Double, dz As Double, htc As Double) As Integer


Private Declare Function _
vhtcEvapSteinerBonn Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, q As Double, d As Double, htc As Double) As Integer

Private Declare Function _
vhtcEvapSteinerVDI Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, q As Double, d As Double, dz As Double, angle As Double, dmin As Double, htc As Double) As Integer

Private Declare Function _
vhtcEvapGungorWinterton87 Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, q As Double, d As Double, htc As Double) As Integer

Private Declare Function _
vhtcEvapKandlikar Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, q As Double, d As Double, incl As Double, htc As Double) As Integer

Private Declare Function _
vhtcEvapBennetChenMod Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, q As Double, d As Double, htc As Double) As Integer

Private Declare Function _
vhtcEvapBennetChen Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double,x As Double, q As Double, d As Double, htc As Double) As Integer

Private Declare Function _
vhtcCondAkers Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double,x As Double, d As Double, htc As Double) As Integer


Private Declare Function _
vhtcCondCavalliniZecchin Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double,x As Double, d As Double, htc As Double) As Integer

Private Declare Function _
vhtcCondMoserWebb Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, dz As Double, htc As Double) As Integer

Private Declare Function _
vhtcCondWang99 Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double,  qfl As Double, t As Double, p As Double, x As Double, d As Double, dz As Double, htc As Double) As Integer

Private Declare Function _
vhtcCondTraviss Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, htc As Double) As Integer


Private Declare Function _
vhtcCondNusselt Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, t As Double, qfl As Double, H As Double, htc As Double) As Integer

Private Declare Function _
vhtcCondNusseltRohsenow Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, t As Double, qfl As Double, H As Double, htc As Double) As Integer


Private Declare Function _
vhtcConvEvapVDI Lib "c:\kktdlls\vhtclib.dll" _
                 (ByVal Refr As String, M As Double, t As Double, p As Double, x As Double, d As Double, dz As Double, angle As Double, htc As Double) As Integer

Private Declare Function _
vhtcNuclTranWambsganns97 Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, q As Double, t As Double, p As Double, d As Double, htc As Double) As Integer


Private Declare Function _
vhtcNuclVDI Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, x As Double, q As Double, t As Double, p As Double, d As Double, rp As Double, angle As Double, dmin As Double, htc As Double) As Integer


Private Declare Function _
vhtcNuclSteiner Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, x As Double, q As Double, t As Double, p As Double, d As Double, rp As Double, htc As Double) As Integer

Private Declare Function _
vhtcNuclStephan Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, q As Double, t As Double, p As Double, d As Double, rp As Double, htc As Double) As Integer

Private Declare Function _
vhtcxCritVDI Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, q As Double, t As Double, p As Double, d As Double, xc As Double) As Integer

Private Declare Function _
vhtcdxCritVDI Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, M As Double, q As Double, t As Double, p As Double, d As Double, dxc As Double) As Integer

Private Declare Function _
vhtcNuclGorenflo Lib "c:\kktdlls\vhtclib.dll" _
(ByVal Refr As String, qfl As Double, t As Double, p As Double, rp As Double, htc As Double) As Integer

Option Base 1

Private Function checkError(ierr, answ)
     If (ierr = 1) Then
       fret = answ
     ElseIf (ierr = 0) Then
       fret = "Error selecting refrigerant"
     ElseIf (ierr = -1) Then
       fret = "Error: Massflow must be > 0!"
     ElseIf (ierr = -2) Then
       fret = "Error: Hydraulic diameter must be > 0"
     ElseIf (ierr = -3) Then
       fret = "Error: Single phase correlation for two-phase flow"
     End If
     checkError = fret
End Function



Public Function htcGascooler(Rnr, M, t, p, x, d)
Attribute htcGascooler.VB_Description = "Heat transfer coeffient for a gascooler/condenser\r\nInput: Refrigerant no., Massflux, temperature, pressure, diameter"
       ret = vhtcGascooler(Rnr, M, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcGascooler = fret
End Function


Public Function htcSingleDittusBoelter(Rnr, M, t, p, x, d)
Attribute htcSingleDittusBoelter.VB_Description = "Single phase heat transfer using the DittusBoelter correlation"
       ret = vhtcSingleDittusBoelter(Rnr, M, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcSingleDittusBoelter = fret
End Function


Public Function htcSingleGnielinski(Rnr, M, t, p, x, d, z, k)
Attribute htcSingleGnielinski.VB_Description = "Single phase heat transfer coefficient using the Gnielinski correlation"
       ret = vhtcSingleGnielinski(Rnr, M, t, p, x, d, z, k, htc)
       fret = checkError(ret, htc)
       htcSingleGnielinski = fret
End Function

  
Public Function htcSuperKakac(Rnr, M, t, p, x, d)
Attribute htcSuperKakac.VB_Description = "Super critical heat transfer coefficient for CO2, Kakac et. al."
       ret = vhtcSuperKakac(Rnr, M, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcSuperKakac = fret
End Function

Public Function htcSuperJacksonFewster(Rnr, M, qw, t, p, x, d)
Attribute htcSuperJacksonFewster.VB_Description = "Super critical heat transfer coefficient for CO2, Jackson and Fewster (HTFS)"
       ret = vhtcSuperJacksonFewster(Rnr, M, qw, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcSuperJacksonFewster = fret
End Function

 
Public Function htcSuperPetukhov(Rnr, M, t, p, x, d)
Attribute htcSuperPetukhov.VB_Description = "Super critical heat transfer coefficient for CO2, Pethukov"
       ret = vhtcSuperPetukhov(Rnr, M, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcSuperPetukhov = fret
End Function

  
Public Function htcSuperGhajarAsadi(Rnr, M, qw, t, p, d)
Attribute htcSuperGhajarAsadi.VB_Description = "Super critical heat transfer coefficient for CO2 close to the critical point, Ghajar and Asadi"
       ret = vhtcSuperGhajarAsadi(Rnr, M, qw, t, p, d, htc)
       fret = checkError(ret, htc)
       htcSuperGhajarAsadi = fret
End Function


Public Function htcSuperPolyakov(Rnr, M, qw, t, p, d)
Attribute htcSuperPolyakov.VB_Description = "Super critical heat transfer coefficient for CO2 close to critiacal point, Polyakov"
       ret = vhtcSuperPolyakov(Rnr, M, qw, t, p, d, htc)
       fret = checkError(ret, htc)
       htcSuperPolyakov = fret
End Function

  
Public Function htcEvapKKT(Rnr, M, t, p, x, q, d, dz)
Attribute htcEvapKKT.VB_Description = "Two phase heat transfer correlation, a refined Steiner/Bonn correlation, KKT"
       ret = vhtcEvapKKT(Rnr, M, t, p, x, q, d, dz, htc)
       fret = checkError(ret, htc)
       htcEvapKKT = fret
End Function

  
Public Function htcEvapSteinerBonn(Rnr, M, t, p, x, q, d)
Attribute htcEvapSteinerBonn.VB_Description = "Two phase heat transfer convective and pool boiling, Steiner/Bonn"
       ret = vhtcEvapSteinerBonn(Rnr, M, t, p, x, q, d, htc)
       fret = checkError(ret, htc)
       htcEvapSteinerBonn = fret
End Function

  
Public Function htcEvapSteinerVDI(Rnr, M, t, p, x, q, d, dz, angle, dmin)
Attribute htcEvapSteinerVDI.VB_Description = "Two phase heat transfer using the VDI correlation (convective and pool boiling)"
       ret = vhtcEvapSteinerVDI(Rnr, M, t, p, x, q, d, dz, angle, dmin, htc)
       fret = checkError(ret, htc)
       htcEvapSteinerVDI = fret
End Function

 
Public Function htcEvapGungorWinterton87(Rnr, M, t, p, x, q, d)
Attribute htcEvapGungorWinterton87.VB_Description = "Two phase heat transfer coeffient by Gungor/Winterton, Wide range, General, Gungor and Winterton 87"
       ret = vhtcEvapGungorWinterton87(Rnr, M, t, p, x, q, d, htc)
       fret = checkError(ret, htc)
       htcEvapGungorWinterton87 = fret
End Function

Public Function htcEvapBennetChenMod(Rnr, M, t, p, x, q, d)
Attribute htcEvapBennetChenMod.VB_Description = "Two phase heat transfer coeffient by modified Bennet-Chen (Hwang et. al)"
       ret = vhtcEvapBennetChenMod(Rnr, M, t, p, x, q, d, htc)
       fret = checkError(ret, htc)
       htcEvapBennetChenMod = fret
End Function

Public Function htcEvapBennetChen(Rnr, M, t, p, x, q, d)
Attribute htcEvapBennetChen.VB_Description = "Two phase heat transfer coeffient by Bennet-Chen"
       ret = vhtcEvapBennetChen(Rnr, M, t, p, x, q, d, htc)
       fret = checkError(ret, htc)
       htcEvapBennetChen = fret
End Function

Public Function htcEvapKandlikar(Rnr, M, t, p, x, q, d, incl)
Attribute htcEvapKandlikar.VB_Description = "Two phase heat transfer coeffient by Kandlikar"
       ret = vhtcEvapKandlikar(Rnr, M, t, p, x, q, d, incl,htc)
       fret = checkError(ret, htc)
       htcEvapKandlikar = fret
End Function

 
Public Function htcCondAkers(Rnr, M, t, p, x, d)
Attribute htcCondAkers.VB_Description = "Two phase condending heat transfer, Akers"
       ret = vhtcCondAkers(Rnr, M, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcCondAkers = fret
End Function


Public Function htcCondCavalliniZecchin(Rnr, M, t, p, x, d)
Attribute htcCondCavalliniZecchin.VB_Description = "Two phase condensing heat transfer, Cavallini and Zecchin"
       ret = vhtcCondCavalliniZecchin(Rnr, M, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcCondCavalliniZecchin = fret
End Function

 
Public Function htcCondMoserWebb(Rnr, M, t, p, x, d, dz)
Attribute htcCondMoserWebb.VB_Description = "Two phase condenseing heat transfer, Moser Webb"
       ret = vhtcCondMoserWebb(Rnr, M, t, p, x, d, dz, htc)
       fret = checkError(ret, htc)
       htcCondMoserWebb = fret
End Function

Public Function htcCondWang99(Rnr, M, t, p, x, qfl, d, dz)
Attribute htcCondWang99.VB_Description = "Two phase condenseing heat transfer, Wang et. al 1999"
       ret = vhtcCondWang99(Rnr, M, qfl, t, p, x, d, dz, htc)
       fret = checkError(ret, htc)
       htcCondWang99 = fret
End Function


  
Public Function htcCondTraviss(Rnr, M, t, p, x, d)
Attribute htcCondTraviss.VB_Description = "Two phase condensing heat transfer, Traviss"
       ret = vhtcCondTraviss(Rnr, M, t, p, x, d, htc)
       fret = checkError(ret, htc)
       htcCondTraviss = fret
End Function

Public Function htcCondNusseltRohsenow(Rnr, t, qfl, H)
Attribute htcCondNusseltRohsenow.VB_Description = "Film condensation using Nusselt and Rohsenow correlation"
       ret = vhtcCondNusseltRohsenow(Rnr, t, qfl, H, htc)
       fret = checkError(ret, htc)
       htcCondNusseltRohsenow = fret
End Function

Public Function htcCondNusselt(Rnr, t, qfl, H)
Attribute htcCondNusselt.VB_Description = "Film condensation using Nusselt correlation"
       ret = vhtcCondNusselt(Rnr, t, qfl, H, htc)
       fret = checkError(ret, htc)
       htcCondNusselt = fret
End Function

Public Function htcConvEvapVDI(Rnr, M, t, p, x, d, dz, angle)
Attribute htcConvEvapVDI.VB_Description = "Two phase heat transfer using the VDI correlation (convective part only)"
       ret = vhtcConvEvapVDI(Rnr, M, t, p, x, d, dz, angle, htc)
       fret = checkError(ret, htc)
       htcConvEvapVDI = fret
End Function

Public Function htcNuclTranWambsganns97(Rnr, M, q, t, p, d)
Attribute htcNuclTranWambsganns97.VB_Description = "Nucleate boiling after Tran/Wambsganns97"
       ret = vhtcNuclTranWambsganns97(Rnr, M, q, t, p, d, htc)
       fret = checkError(ret, htc)
       htcNuclTranWambsganns97 = fret
End Function

Public Function htcNuclVDI(Rnr, M, x, q, t, p, d, rp, angle, dmin)
Attribute htcNuclVDI.VB_Description = "Nucleate boiling after VDI"
       ret = vhtcNuclVDI(Rnr, M, x, q, t, p, d, rp, angle, dmin,htc)
       fret = checkError(ret, htc)
       htcNuclVDI = fret
End Function

Public Function htcNuclGorenflo(Rnr, qfl, t, p, rp)
Attribute htcNuclGorenflo.VB_Description = "htcNuclGorenflo"
       ret = vhtcNuclGorenflo(Rnr, qfl, t, p, rp, htc)
       fret = checkError(ret, htc)
       htcNuclGorenflo = fret
End Function

Public Function htcNuclSteiner(Rnr, M, x, q, t, p, d, rp)
Attribute htcNuclSteiner.VB_Description = "htcNuclSteiner"
       ret = vhtcNuclSteiner(Rnr, M, x, q, t, p, d, rp, htc)
       fret = checkError(ret, htc)
       htcNuclSteiner = fret
End Function

Public Function htcNuclStephan(Rnr, M, q, t, p, d, rp)
Attribute htcNuclStephan.VB_Description = "htcNuclStephan"
       ret = vhtcNuclStephan(Rnr, M, q, t, p, d, rp, htc)
       fret = checkError(ret, htc)
       htcNuclStephan = fret
End Function


Public Function htcxCritVDI(Rnr, M, q, t, p, d)
Attribute htcxCritVDI.VB_Description = "Calculation of critical vapour fraction after Ahmad method"
       ret = vhtcxCritVDI(Rnr, M, q, t, p, d, xc)
       fret = checkError(ret, xc)
       htcxCritVDI = fret
End Function

Public Function htcdxCritVDI(Rnr, M, q, t, p, d)
Attribute htcdxCritVDI.VB_Description = "Calculation of critical upper/lower values of critical vapour fraction after Ahmad method"
       ret = vhtcdxCritVDI(Rnr, M, q, t, p, d, dxc)
       fret = checkError(ret, dxc)
       htcdxCritVDI = fret
End Function









